import React, { createContext, useMemo, useEffect } from 'react';
import useObject from '../hooks/useObject';
export const AttachmentViewerServiceContext = /*#__PURE__*/createContext();
export const AttachmentViewerServiceProvider = props => {
  const {
    children,
    Component
  } = props;

  function modifiyProps() {
    const modifiedProps = { ...props
    };
    delete modifiedProps.children;
    return modifiedProps;
  }

  const {
    object: attachment,
    setObjectValue: showAttachmentViewer,
    clearObjectValue: hideAttachmentViewer
  } = useObject();
  const contextValue = useMemo(() => ({
    attachment,
    showAttachmentViewer,
    hideAttachmentViewer
  }), [attachment, showAttachmentViewer, hideAttachmentViewer]);
  return /*#__PURE__*/React.createElement(AttachmentViewerServiceContext.Provider, {
    value: contextValue
  }, children, /*#__PURE__*/React.createElement(Component, {
    attachment: attachment,
    hideAttachmentViewer: hideAttachmentViewer,
    ...modifiyProps()
  }));
};
export const AttachmentViewerConsumer = AttachmentViewerServiceContext.Consumer;
export default AttachmentViewerServiceContext;