import { DUMMY_OBJECT } from "./constant";
const eventListenersMap = new Map();
export const dispatchCustomEvent = _ref => {
  let {
    eventName,
    detail,
    dispatchElementRef
  } = _ref;
  const event = new CustomEvent(eventName, {
    detail
  });

  if (dispatchElementRef) {
    dispatchElementRef.dispatchEvent(event);
  } else {
    window.dispatchEvent(event);
  }
};
export const addCustomEventListener = _ref2 => {
  let {
    eventName,
    callback,
    dispatchElementRef
  } = _ref2;
  const target = dispatchElementRef || window;
  const listeners = eventListenersMap.get(target) || DUMMY_OBJECT;

  if (!listeners[eventName]) {
    target.addEventListener(eventName, callback);
    listeners[eventName] = callback;
    eventListenersMap.set(target, listeners);
  }
};
export const removeCustomEventListener = _ref3 => {
  let {
    eventName,
    callback,
    dispatchElementRef
  } = _ref3;
  const target = dispatchElementRef || window;
  const listeners = eventListenersMap.get(target);

  if (listeners && listeners[eventName]) {
    target.removeEventListener(eventName, callback);
    delete listeners[eventName];

    if (Object.keys(listeners).length === 0) {
      eventListenersMap.delete(target);
    } else {
      eventListenersMap.set(target, listeners);
    }
  }
};