import { emptyObject, mergeObjects, updateObjectValue as replaceObjectValueHelper, removeObjectKeys as deleteObjectValueHelper } from '../helpers/objectCRUD';
import { DUMMY_OBJECT } from '../helpers/constant';

const handleObjectCURD = function () {
  let initialObject = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DUMMY_OBJECT;
  let object = initialObject;

  const setObjectValue = newObject => {
    object = mergeObjects({
      object,
      newObject
    });
  };

  const clearObjectValue = () => {
    object = emptyObject();
  };

  const updateObjectValue = (key, value) => {
    object = replaceObjectValueHelper({
      object,
      key,
      value
    });
  };

  const removeObjectKeys = key => {
    object = deleteObjectValueHelper({
      object,
      key
    });
  };

  return {
    object,
    setObjectValue,
    clearObjectValue,
    updateObjectValue,
    removeObjectKeys
  };
};

export default handleObjectCURD;