import React, { forwardRef } from 'react';
import useAttachmentViewerService from '../hooks/useAttachmentViewerService';

const WithAttachmentViewerService = Component => {
  const WrappedComponent = /*#__PURE__*/forwardRef((props, ref) => {
    const attachmentViewerProperties = useAttachmentViewerService();
    return /*#__PURE__*/React.createElement(Component, { ...props,
      ref: ref,
      attachmentViewerProperties: attachmentViewerProperties
    });
  });
  WrappedComponent.displayName = `WithAttachmentViewer(${Component.displayName || Component.name || 'Component'})`;
  return WrappedComponent;
};

export default WithAttachmentViewerService;