import React, { forwardRef } from 'react';
import useToastNotificationService from '../hooks/useToastNotificationService';

const WithToastNotificationService = Component => {
  const WrappedComponent = /*#__PURE__*/forwardRef((props, ref) => {
    const toastProperties = useToastNotificationService();
    return /*#__PURE__*/React.createElement(Component, { ...props,
      ref: ref,
      toastProperties: toastProperties
    });
  });
  WrappedComponent.displayName = `WithToastNotification(${Component.displayName || Component.name || 'Component'})`;
  return WrappedComponent;
};

export default WithToastNotificationService;