import { appendToArray, deleteFromArray, modifyArrayItem, emptyArray } from '../helpers/arrayCRUD';
import { DUMMY_ARRAY } from '../helpers/constant';
let array = DUMMY_ARRAY;

const handleArrayCURD = () => {
  const addItem = item => {
    const modifiedArray = appendToArray({
      array,
      item
    });
    array = modifiedArray; // return modifiedArray
  };

  const removeItem = id => {
    const modifiedArray = deleteFromArray({
      array,
      id
    });
    array = modifiedArray; // return modifiedArray
  };

  const clearItems = () => {
    const modifiedArray = emptyArray();
    array = modifiedArray; // return modifiedArray
  };

  const updateItem = (id, newItem) => {
    const modifiedArray = modifyArrayItem({
      array,
      id,
      newItem
    });
    array = modifiedArray; // return modifiedArray
  };

  return {
    addItem,
    removeItem,
    clearItems,
    updateItem,
    getArray: () => array
  };
};

export default handleArrayCURD;