"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ToastNotificationServiceProvider = exports.ToastNotificationServiceContext = exports.ToastNotificationConsumer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _useArray2 = _interopRequireDefault(require("../hooks/useArray"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ToastNotificationServiceContext = /*#__PURE__*/(0, _react.createContext)();
exports.ToastNotificationServiceContext = ToastNotificationServiceContext;

var ToastNotificationServiceProvider = function ToastNotificationServiceProvider(props) {
  var children = props.children,
      Component = props.Component;
  var idCounter = (0, _react.useRef)(0);

  function modifiyProps() {
    var modifiedProps = _objectSpread({}, props);

    delete modifiedProps.children;
    return modifiedProps;
  }

  var _useArray = (0, _useArray2["default"])(),
      toastMessages = _useArray.array,
      addItem = _useArray.addItem,
      hideToastNotification = _useArray.removeItem,
      clearToastNotifications = _useArray.clearItems;

  var appendIdInObject = (0, _react.useCallback)(function (item) {
    var id = "item".concat(idCounter.current++);
    var modifiedItem = {
      id: id,
      data: item
    };
    addItem(modifiedItem);
  }, [addItem]);
  var showToastNotification = (0, _react.useCallback)(function (item) {
    appendIdInObject(item);
  }, [appendIdInObject]);
  var contextValue = (0, _react.useMemo)(function () {
    return {
      toastMessages: toastMessages,
      showToastNotification: showToastNotification,
      hideToastNotification: hideToastNotification,
      clearToastNotifications: clearToastNotifications
    };
  }, [toastMessages, showToastNotification, hideToastNotification, clearToastNotifications]);
  return /*#__PURE__*/_react["default"].createElement(ToastNotificationServiceContext.Provider, {
    value: contextValue
  }, children, /*#__PURE__*/_react["default"].createElement(Component, _extends({
    messages: toastMessages,
    hideToastNotification: hideToastNotification,
    clearToastNotifications: clearToastNotifications
  }, modifiyProps())));
};

exports.ToastNotificationServiceProvider = ToastNotificationServiceProvider;
var ToastNotificationConsumer = ToastNotificationServiceContext.Consumer;
exports.ToastNotificationConsumer = ToastNotificationConsumer;
var _default = ToastNotificationServiceContext;
exports["default"] = _default;