"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setGlobalService = exports.removeGlobalService = void 0;

var setGlobalService = function setGlobalService(serviceName, serviceFunctions) {
  if (!global.DOTServices) {
    global.DOTServices = {};
  }

  global.DOTServices[serviceName] = serviceFunctions;
};

exports.setGlobalService = setGlobalService;

var removeGlobalService = function removeGlobalService(serviceName) {
  if (global.DOTServices && global.DOTServices[serviceName]) {
    delete global.DOTServices[serviceName];
  }

  if (global.DOTServices && Object.keys(global.DOTServices).length === 0) {
    delete global.DOTServices;
  }
};

exports.removeGlobalService = removeGlobalService;