"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectCRUD = require("../helpers/objectCRUD");

var _constant = require("../helpers/constant");

var handleObjectCURD = function handleObjectCURD() {
  var initialObject = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constant.DUMMY_OBJECT;
  var object = initialObject;

  var setObjectValue = function setObjectValue(newObject) {
    object = (0, _objectCRUD.mergeObjects)({
      object: object,
      newObject: newObject
    });
  };

  var clearObjectValue = function clearObjectValue() {
    object = (0, _objectCRUD.emptyObject)();
  };

  var updateObjectValue = function updateObjectValue(key, value) {
    object = (0, _objectCRUD.updateObjectValue)({
      object: object,
      key: key,
      value: value
    });
  };

  var removeObjectKeys = function removeObjectKeys(key) {
    object = (0, _objectCRUD.removeObjectKeys)({
      object: object,
      key: key
    });
  };

  return {
    object: object,
    setObjectValue: setObjectValue,
    clearObjectValue: clearObjectValue,
    updateObjectValue: updateObjectValue,
    removeObjectKeys: removeObjectKeys
  };
};

var _default = handleObjectCURD;
exports["default"] = _default;