"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _handleArrayCURD2 = _interopRequireDefault(require("./helpers/handleArrayCURD"));

var _eventDispatcher = require("./helpers/eventDispatcher");

var _constant = require("./helpers/constant");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useDOTToastNotificationService = function useDOTToastNotificationService() {
  var _useState = useState(DUMMY_ARRAY),
      _useState2 = _slicedToArray(_useState, 2),
      notifications = _useState2[0],
      setNotification = _useState2[1];

  var _handleArrayCURD = (0, _handleArrayCURD2["default"])(),
      _showToastNotification = _handleArrayCURD.addItem,
      _hideToastNotification = _handleArrayCURD.removeItem,
      _clearToastNotifications = _handleArrayCURD.clearItems,
      _getToastNotifications = _handleArrayCURD.getArray;

  var toastIdCounter = useRef(0);

  var handleService = function handleService(event) {
    var _event$detail = event.detail,
        type = _event$detail.type,
        payload = _event$detail.payload;

    switch (type) {
      case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION:
        var id = "toast".concat(toastIdCounter.current++);
        var toastMessage = {
          id: id,
          data: payload
        };

        _showToastNotification(toastMessage);

        setNotification(_getToastNotifications());
        break;

      case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION:
        _hideToastNotification(payload.id);

        setNotification(_getToastNotifications());
        break;

      case _constant.DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION:
        _clearToastNotifications();

        setNotification(_getToastNotifications());
        break;

      default:
        console.error('No such service found in DOT Toast Notification Service');
        break;
    }
  };

  useEffect(function () {
    // Add event listener
    (0, _eventDispatcher.addCustomEventListener)({
      eventName: _constant.DOT_SERVICE_EVENT,
      callback: handleService
    });
    return function () {
      // Return a cleanup function to remove the event listener
      (0, _eventDispatcher.removeCustomEventListener)({
        eventName: _constant.DOT_SERVICE_EVENT,
        callback: handleService
      });
    };
  }, []);
  return {
    notifications: notifications
  };
};

var _default = useDOTToastNotificationService;
exports["default"] = _default;