"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _Common = require("@zohodesk/components/es/utils/Common");

var _getAttributeValues = _interopRequireDefault(require("../helpers/getAttributeValues"));

var _constant = require("../helpers/constant");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useEventService = function useEventService(properties) {
  var _properties$attribute = properties.attributes,
      attributes = _properties$attribute === void 0 ? _constant.DUMMY_ARRAY : _properties$attribute,
      keyAttribute = properties.keyAttribute,
      isRendered = properties.isRendered,
      onClick = properties.onClick;
  var attributesValue = (0, _react.useRef)(_constant.DUMMY_OBJECT);
  (0, _react.useEffect)(function () {
    if (!isRendered) {
      attributesValue.current = _constant.DUMMY_OBJECT;
    }
  }, [isRendered]);
  var handleClick = (0, _react.useCallback)(function (event) {
    (0, _Common.cancelBubblingEffect)(event);
    var target = event.target.getAttribute(keyAttribute) || event.target.closest("[".concat(keyAttribute, "]"));

    if (target) {
      var attributeData = (0, _getAttributeValues["default"])({
        element: event.target,
        attributes: attributes
      });

      if (Object.keys(attributeData).length > 0) {
        attributesValue.current = attributeData;
      }

      if (typeof onClick === 'function') {
        onClick(event);
      }
    }
  }, [attributes, keyAttribute, onClick]);
  (0, _react.useEffect)(function () {
    document.addEventListener('click', handleClick);
    return function () {
      document.removeEventListener('click', handleClick);
    };
  }, [handleClick]);
  var attributeValues = (0, _react.useMemo)(function () {
    return attributesValue.current;
  }, [attributesValue.current]);
  return {
    attributeValues: attributeValues
  };
};

var _default = useEventService;
exports["default"] = _default;