"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _handleObjectCURD2 = _interopRequireDefault(require("./helpers/handleObjectCURD"));

var _eventDispatcher = require("./helpers/eventDispatcher");

var _constant = require("./helpers/constant");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useDOTAttachmentViewerService = function useDOTAttachmentViewerService() {
  var _handleObjectCURD = (0, _handleObjectCURD2["default"])(),
      attachment = _handleObjectCURD.object,
      showAttachmentViewer = _handleObjectCURD.setObjectValue,
      hideAttachmentViewer = _handleObjectCURD.clearObjectValue;

  var handleService = function handleService(event) {
    var _event$detail = event.detail,
        type = _event$detail.type,
        payload = _event$detail.payload;

    switch (type) {
      case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_ATTACHMENT_VIEWER:
        showAttachmentViewer(payload);
        break;

      case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_ATTACHMENT_VIEWER:
        hideAttachmentViewer();
        break;

      default:
        console.error('No such service found in DOT Attachment Viewer Service');
        break;
    }
  }; // Add event listener


  (0, _eventDispatcher.addCustomEventListener)({
    eventName: _constant.DOT_SERVICE_EVENT,
    callback: handleService
  }); // Return a cleanup function to remove the event listener

  var cleanup = function cleanup() {
    (0, _eventDispatcher.removeCustomEventListener)({
      eventName: _constant.DOT_SERVICE_EVENT,
      callback: handleService
    });
  };

  return {
    getAttachment: function getAttachment() {
      return attachment;
    },
    showAttachmentViewer: showAttachmentViewer,
    hideAttachmentViewer: hideAttachmentViewer,
    cleanup: cleanup
  };
};

var _default = useDOTAttachmentViewerService;
exports["default"] = _default;