"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _handleArrayCURD2 = _interopRequireDefault(require("./helpers/handleArrayCURD"));

var _eventDispatcher = require("./helpers/eventDispatcher");

var _constant = require("./helpers/constant");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useDOTToastNotificationService = function useDOTToastNotificationService() {
  var _handleArrayCURD = (0, _handleArrayCURD2["default"])(),
      toastNotifications = _handleArrayCURD.array,
      showToastNotification = _handleArrayCURD.addItem,
      hideToastNotification = _handleArrayCURD.removeItem,
      clearToastNotifications = _handleArrayCURD.clearItems;

  var handleService = function handleService(event) {
    var _event$detail = event.detail,
        type = _event$detail.type,
        payload = _event$detail.payload;

    switch (type) {
      case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION:
        showToastNotification(payload);
        break;

      case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION:
        hideToastNotification(payload.id);
        break;

      case _constant.DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION:
        clearToastNotifications();
        break;

      default:
        console.error('No such service found in DOT Toast Notification Service');
        break;
    }
  }; // Add event listener


  (0, _eventDispatcher.addCustomEventListener)({
    eventName: _constant.DOT_SERVICE_EVENT,
    callback: handleService
  }); // Return a cleanup function to remove the event listener

  var cleanup = function cleanup() {
    (0, _eventDispatcher.removeCustomEventListener)({
      eventName: _constant.DOT_SERVICE_EVENT,
      callback: handleService
    });
  };

  return {
    getToastNotifications: function getToastNotifications() {
      return toastNotifications;
    },
    showToastNotification: showToastNotification,
    hideToastNotification: hideToastNotification,
    clearToastNotifications: clearToastNotifications,
    cleanup: cleanup
  };
};

var _default = useDOTToastNotificationService;
exports["default"] = _default;