"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getElementSpace = getElementSpace;

function getElementSpace(elementRef) {
  var neededSpace = 0,
      availableInsideSpace = 0;

  if (elementRef) {
    var getStyle = window.getComputedStyle(elementRef);
    var margin = parseFloat(getStyle.marginLeft) + parseFloat(getStyle.marginRight);
    var padding = parseFloat(getStyle.paddingLeft) + parseFloat(getStyle.paddingRight);
    var width = parseFloat(elementRef.offsetWidth);
    neededSpace = width + margin;
    availableInsideSpace = width - padding;
  }

  return {
    neededSpace: neededSpace,
    availableInsideSpace: availableInsideSpace
  };
}