"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeCustomEventListener = exports.dispatchCustomEvent = exports.addCustomEventListener = void 0;

// import { DUMMY_ARRAY, DUMMY_OBJECT } from "./constant";
// const eventListenersMap = new Map();
var dispatchCustomEvent = function dispatchCustomEvent(_ref) {
  var eventName = _ref.eventName,
      detail = _ref.detail,
      dispatchElementRef = _ref.dispatchElementRef;
  var event = new CustomEvent(eventName, {
    bubbles: true,
    detail: detail
  });

  if (dispatchElementRef) {
    dispatchElementRef.dispatchEvent(event);
  } else {
    window.dispatchEvent(event);
  }
};

exports.dispatchCustomEvent = dispatchCustomEvent;

var addCustomEventListener = function addCustomEventListener(_ref2) {
  var eventName = _ref2.eventName,
      callback = _ref2.callback,
      dispatchElementRef = _ref2.dispatchElementRef;
  var target = dispatchElementRef || window; // const listeners = eventListenersMap.get(target) || DUMMY_OBJECT;
  // if (!listeners[eventName]) {
  //     listeners[eventName] = DUMMY_ARRAY;
  // }
  // listeners[eventName].push(callback);

  target.addEventListener(eventName, callback); // eventListenersMap.set(target, listeners);
};

exports.addCustomEventListener = addCustomEventListener;

var removeCustomEventListener = function removeCustomEventListener(_ref3) {
  var eventName = _ref3.eventName,
      callback = _ref3.callback,
      dispatchElementRef = _ref3.dispatchElementRef;
  var target = dispatchElementRef || window; // const listeners = eventListenersMap.get(target);
  // if (listeners && listeners[eventName]) {
  // const index = listeners[eventName].indexOf(callback);

  if (index !== -1) {
    // listeners[eventName].splice(index, 1);
    target.removeEventListener(eventName, callback);
  } // if (listeners[eventName].length === 0) {
  //     delete listeners[eventName];
  // }
  // if (Object.keys(listeners).length === 0) {
  //     eventListenersMap.delete(target);
  // } else {
  //     eventListenersMap.set(target, listeners);
  // }
  // }

};

exports.removeCustomEventListener = removeCustomEventListener;