"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _arrayCRUD = require("../helpers/arrayCRUD");

var _constant = require("../helpers/constant");

var array = _constant.DUMMY_ARRAY;

var handleArrayCURD = function handleArrayCURD() {
  var addItem = function addItem(item) {
    var modifiedArray = (0, _arrayCRUD.appendToArray)({
      array: array,
      item: item
    });
    array = modifiedArray; // return modifiedArray
  };

  var removeItem = function removeItem(id) {
    var modifiedArray = (0, _arrayCRUD.deleteFromArray)({
      array: array,
      id: id
    });
    array = modifiedArray; // return modifiedArray
  };

  var clearItems = function clearItems() {
    var modifiedArray = (0, _arrayCRUD.emptyArray)();
    array = modifiedArray; // return modifiedArray
  };

  var updateItem = function updateItem(id, newItem) {
    var modifiedArray = (0, _arrayCRUD.modifyArrayItem)({
      array: array,
      id: id,
      newItem: newItem
    });
    array = modifiedArray; // return modifiedArray
  };

  return {
    addItem: addItem,
    removeItem: removeItem,
    clearItems: clearItems,
    updateItem: updateItem,
    getArray: function getArray() {
      return array;
    }
  };
};

var _default = handleArrayCURD;
exports["default"] = _default;