"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectCRUD = require("../helpers/objectCRUD");

var _constant = require("../helpers/constant");

var object = _constant.DUMMY_OBJECT;

var handleObjectCURD = function handleObjectCURD() {
  var setObjectValue = function setObjectValue(newObject) {
    var modifiedObject = (0, _objectCRUD.mergeObjects)({
      object: object,
      newObject: newObject
    });
    object = modifiedObject; // return modifiedObject
  };

  var clearObjectValue = function clearObjectValue() {
    var modifiedObject = (0, _objectCRUD.emptyObject)();
    object = modifiedObject; // return modifiedObject
  };

  var updateObjectValue = function updateObjectValue(key, value) {
    var modifiedObject = (0, _objectCRUD.updateObjectValue)({
      object: object,
      key: key,
      value: value
    });
    object = modifiedObject; // return modifiedObject
  };

  var removeObjectKeys = function removeObjectKeys(key) {
    var modifiedObject = (0, _objectCRUD.removeObjectKeys)({
      object: object,
      key: key
    });
    object = modifiedObject; // return modifiedObject
  };

  return {
    setObjectValue: setObjectValue,
    clearObjectValue: clearObjectValue,
    updateObjectValue: updateObjectValue,
    removeObjectKeys: removeObjectKeys,
    getObject: function getObject() {
      return object;
    }
  };
};

var _default = handleObjectCURD;
exports["default"] = _default;